#include "enigma.h"
#include "bomb.h"

static string rotorLoc = "AAA";
static string plain = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
static bool debugFlag = false;

using namespace EnigmaLibrary;

/*
	error : 顼åȥإפɽƽλ
*/
void error( const string& message )
{
	cerr << message << endl << endl;

	cerr << "Usage : bomb [-pXXX...] [-d] [-h] []" << endl;
	cerr << "\t-p ... ʿʸʸ(ե٥å)" << endl;
	cerr << "\t-d ... ǥХå" << endl;
	cerr << "\t-h ... إ" << endl;

	exit( -1 );
}

/*
	getArgs : 

	int argc : θĿ
	char* argv[] : 
*/
void getArgs( int argc, char* argv[] )
{
	for ( int i = 1 ; i < argc ; i++ ) {
		if ( argv[i][0] == '-' ) {
			switch( tolower( argv[i][1] ) ) {
			case 'd':
				debugFlag = true;
				break;
			case 'p':
				plain = &argv[i][2];
				break;
			case 'h':
				error( "" );
				break;
			default:
				break;
			}
		} else {
			rotorLoc = argv[i];
			if ( rotorLoc.length() != 3 )
				error( "֤ϣʸǻꤷƤ" );
			for ( unsigned int i = 0 ; i < rotorLoc.length() ; i++ ) {
				if ( ! isalpha( rotorLoc[i] ) )
					error( "֤ϥե٥åȤǻꤷƤ" );
				rotorLoc[i] = toupper( rotorLoc[i] );
			}
		}
	}
}

/*
	checkPlain : plainΥå

	plain饢ե٥åȰʳñʸʸѴ
*/
void checkPlain( string& plain )
{
	for ( unsigned int i = plain.length() ; i > 0 ; i-- ) {
		if ( ! isalpha( plain[i - 1] ) )
			plain.erase( i - 1, 1 );
		else
			plain[i - 1] = toupper( plain[i - 1] );
	}
}

/*
	createLoop : 롼׹

	string plain : ʿʸʸ
	Enigma& enigma : Ѥ륨˥
	vector<VecUInt>& vec : 롼פϿ뤿Υ٥

	plainƬʸ˰ưʤŹ沽롼׺򷫤֤

	 : Ͽ٥οĤǤ⤢ trueǤʤ false
*/
bool createLoop( string plain, Enigma& enigma, vector<VecUInt>& vec )
{
	for ( unsigned int i = 0 ; i < plain.length() ; i++ ) {
		enigma.init( rotorLoc );
		string crypto = enigma.convert( plain );

		vector<VecUInt> v = makeAllLoop( plain, crypto, 3 );
		vec.insert( vec.end(), v.begin(), v.end() );

		plain += plain[0];
		plain = plain.substr( 1 );
	}

	return( vec.size() >= 1 );
}

/// ᥤ롼
int main( int argc, char* argv[] )
{
	getArgs( argc, argv );

	checkPlain( plain );

	Enigma enigma( 'A', 'Z' );

	vector<VecUInt> vec;
	if ( ! createLoop( plain, enigma, vec ) )
		error( "롼פǤޤǤ" );

	vector<string> decode;
	cout << "ɳ" << endl;
	for ( unsigned int i = 0 ; i < vec.size() ; i++ ) {

		if ( debugFlag ) {
			cout << "롼׹ : ";
			for ( unsigned int j = 0 ; j < vec[i].size() - 1 ; j++ )
				cout << vec[i][j] << "->";
			cout << vec[i][vec[i].size() - 1] << endl;
		} else {
			cout << ".";
			cout.flush();
		}

		Bomb bomb = Bomb( enigma, vec[i], debugFlag );

		if ( i == 0 )
			decode = bomb.decode();
		else
			bomb.decode( decode );

		if ( debugFlag )
			cout << "֤θ : " << decode.size() << endl;
	}

	cout << endl << "֤θ" << endl;
	for ( unsigned int i = 0 ; i < decode.size() ; i++ )
		cout << " " << decode[i] << endl;
	cout << " : " << rotorLoc << endl;

	return( 0 );
}
