#ifndef ENIGMA_H
#define ENIGMA_H

#include <stdlib.h>
#include <sys/time.h>

#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <map>

using namespace std;

namespace EnigmaLibrary
{
	// إѴؿ

	/*
		getSeedOfRand μ
	*/
	void getSeedOfRand();

	/*
		vectorǤ򥹥֥뤹

		vector<unsigned int>& vec : ֥뤹vector
		unsigned int length : vectorνǿ
		unsigned int count : ֥
	*/
	void scramble( vector<unsigned int>& vec, unsigned int length, unsigned int count );

	/*
		swap VectorǤ򴹤

		vector<T>& vec : оݤVector
		unsigned int i1, i2 : 򴹤ǤΥǥå
	 */
	template<class T> bool swap( vector<T>& vec, unsigned int i1, unsigned int i2 )
	{
		if ( i1 >= vec.size() || i2 >= vec.size() ) return( false );
		if ( i1 == i2 ) return( true );

		T buff = vec[i1];
		vec[i1] = vec[i2];
		vec[i2] = buff;

		return( true );
	}

	/*
		˥ѥ󥿡ե(Keyboard,Lumpboard)
	*/
	class EnigmaIF {
		string key; // ܡɾʸɤɽʸ

	public:

		/*
			EnigmaIF 󥹥ȥ饯

			unsigned char start : ܡɤγʸ
			unsigned char end : ܡɤνλʸ

			ϰstartendǡԲǽʥɤϽ
		*/
		EnigmaIF( unsigned char start = 1, unsigned char end = UCHAR_MAX );

		/*
			EnigmaIF::keyIn ϥΥǥå֤

			unsigned char c : ϥ

			 : ϥΥǥå
			        (ĤʤäǸǤμΥǥå֤)
		*/
		unsigned int keyIn( unsigned char c ) const;

		// EnigmaIF::keyOut ꥤǥåΥ֤(ϰϳξ϶ʸ֤)
		unsigned char keyOut( unsigned int i ) const { return( ( i >= size() ) ? ' ' : key[i] ); }

		// EnigmaIF::size ܡɾʸ֤
		unsigned int size() const { return( key.length() ); }

		// EnigmaIF::print ¤ν
		void print() const;
	};

	/*
		˥ѥ
	*/
	class Rotor {
		vector<unsigned int> inShift;	// ϻΥե
		vector<unsigned int> outShift; // ϻΥե
		unsigned int location;				 // ΰ

	public:

		/*
			Rotor 󥹥ȥ饯

			unsigned int length : ʸ
			unsigned int randomizeCount : 򥹥֥뤹
		*/
		Rotor( unsigned int length, unsigned int randomizeCount = 1000 );

		// Rotor::size ʸ֤
		unsigned int size() const { return( inShift.size() ); }

		/*
			Rotor::encode Ź沽

			unsigned int i : ϰ

			 : ϰ(ϰϳξϰ֤򤽤Τޤ֤)
		*/
		unsigned int encode( unsigned int i ) const;

		/*
			Rotor::decode 沽

			unsigned int i : ϰ

			 : ϰ(ϰϳξϰ֤򤽤Τޤ֤)
		*/
		unsigned int decode( unsigned int i ) const;

		/*
			Rotor::rotate ž

			 : ž˸ätrue֤
		*/
		bool rotate();

		/*
			Rotor::rotate ղž

			 : ղž˸ätrue֤
		*/
		bool negRotate();

		// Rotor::init ֤ν
		void init() { init( 0 ); }

		/*
			Rotor::init ֤֤˽

			unsigned int i : 
		*/
		void init( unsigned int i ) { location = i % size(); }

		// Rotor::current θ֤֤߰
		unsigned int current() const { return( location ); }

		// Rotor::print ¤ν
		void print() const;
	};

	/*
		˥ѥե쥯
	*/
	class Reflector {
		// ͤ򼨤٥
		// ͤΰ֤ФǤͤȤʤ out = reflector[in]
		vector<unsigned int> reflector;

	public:

		/*
			Reflector 󥹥ȥ饯

			unsigned int length : ե쥯ʸ
		*/
		Reflector( unsigned int length );

		// Reflector::size ե쥯ʸ֤
		unsigned int size() const { return( reflector.size() ); }

		/*
			Reflector::operator[] ϥǡФ֤ͤ

			unsigned int i : ϥǡ

			 : (ϰϳξϥǡ򤽤Τޤ֤)
		*/
		unsigned int operator[]( unsigned int i ) const;

		// Reflector::print ¤ν
		void print() const;
	};

	/*
		˥ѥץ饰ܡ
	*/
	class PlugBoard {
		// ץ饰ܡɤˤäѴ줿ͤ򼨤٥
		// ͤΰ֤ФǤͤȤʤ out = plug[in]
		vector<unsigned int> plug;

	public:

		/*
			PlugBoard 󥹥ȥ饯

			unsigned int length : ϤǤʸο
			unsigned int exchangeCount : ʸθ򴹤ǽʿ
		*/
		PlugBoard( unsigned int length, unsigned int exchangeCount = 6 ) { scramble( plug, length, exchangeCount ); }

		/*
			PlugBoard::exchange ץ饰򴹤

			unsigned int i1, i2 : 򴹤
		*/
		bool exchange( unsigned int i1, unsigned int i2 );

		// PlugBoard::reset ץ饰ꥻåȤ
		void reset();

		// PlugBoard::size ץ饰ܡʸ(򴹤Ƥʤʸޤ)֤
		unsigned int size() const { return( plug.size() ); }

		/*
			PlugBoard::encode/PlugBoard::decode Ź沽沽(Ʊ)

			unsigned int i : ϥǥå

			 : Ź(ϰϳξϥǥå򤽤Τޤ֤)
		*/
		unsigned int encode( unsigned int i ) const { return( ( i >= plug.size() ) ? i : plug[i] ); }
		unsigned int decode( unsigned int i ) const { return( encode( i ) ); }

		// PlugBoard::print ¤ν
		void print() const;
	};

	/*
		˥
	*/
	class Enigma {
		EnigmaIF* enigmaIF;			// ܡɤȥץܡ
		vector<Rotor*> vecRotor; // Υ٥
		Reflector* reflector;		// ե쥯
		PlugBoard* plugBoard;		// ץ饰ܡ

	public:
		/*
			Enigma 󥹥ȥ饯

			unsigned char start : ܡɤγʸ
			unsigned char end : ܡɤνλʸ
			unsigned int rotorCount : ο
			unsigned int exchangeCount : ץ饰ܡɤθ򴹲
		*/
		Enigma( unsigned char start = 1, unsigned char end = UCHAR_MAX, unsigned int rotorCount = 3, unsigned int exchangeCount = 6 );

		/*
			Enigma ԡ󥹥ȥ饯

			const Enigma& enigma : ԡ Enigma֥
		*/
		Enigma( const Enigma& enigma );

		// Enigma ǥȥ饯
		~Enigma();

		/*
			Enigma::convert EnigmaʸŹ沽

			const string& inData : ʸ

			 : Ź沽ʸ
		*/
		string convert( const string& inData );

		/*
			Enigma::keyIn ꤷʸֹ֤
			              (ĤʤäǸǤμΥǥå֤)
		*/
		unsigned int keyIn( unsigned char c ) const { return( enigmaIF->keyIn( c ) ); }

		/*
			Enigma::keyOut ꤷΥ֤
			               (ϰϳξ϶ʸ֤)
		*/
		unsigned char keyOut( unsigned int i ) const { return( enigmaIF->keyOut( i ) ); }

		// Enigma::size EnigmaǽǤʸ֤
		unsigned int ioSize() const { return( enigmaIF->size() ); }

		// Enigma::rotorCount ο֤
		unsigned int rotorCount() const { return( vecRotor.size() ); }

		/*
			Enigma::operator= 黻Ҥ¿

			const Enigma& enigma : ԡ Enigma֥

			 : ʬ
		*/
		Enigma& operator=( const Enigma& enigma );

		// Enigma::init ν(ưܤǤˤ)
		void init();

		/*
			Enigma::init ν

			const string& key : ˻Ѥ륭
		*/
		void init( const string& key );

		/*
			Enigma::rotate βž

			ǸΥž0ä餽
			ž

			 : ǤƬˤ0äTrue֤
			        (Ĥޤ0ΰ֤ˤʤäTrue)
		*/
		bool rotate();

		/*
			Enigma::negRotate εղž

			ǸΥղž0η겼꤬ä餽
			ղž

			 : ǤƬˤǷ겼꤬äTrue֤
			        (Ĥޤ0ΰ֤ξ֤ǵղž򤷤True)
		*/
		bool negRotate();

		// Enigma::current ƥΰ֤֤
		string current() const;

		/*
			ץ饰ܡɤΥץ饰

			unsigned int i1, i2 : 򴹤ץ饰ܡɤֹ
		*/
		bool exchangePlug( unsigned int i1, unsigned int i2 ) { return( plugBoard->exchange( i1, i2 ) ); }

		// ץ饰ܡɤΥꥻå
		void resetPlug() { plugBoard->reset(); }

		/*
			Enigma::exchangeRotor θ

			unsigned int i1, i2 : 򴹤ֹ
		*/
		bool exchangeRotor( unsigned int i1, unsigned int i2 );

		// Enigma::print Enigmaѥ᡼ɽ
		void print() const;
	};
}

#endif
